/*
*************************************************************************
**  Copyright (c) 2019 CentraleSupélec & EDF.
**  All rights reserved. This program and the accompanying materials
**  are made available under the terms of the Eclipse Public License v2.0
**  which accompanies this distribution, and is available at
**  https://www.eclipse.org/legal/epl-v20.html
** 
**  This file is part of the RiseClipse tool
**  
**  Contributors:
**      Computer Science Department, CentraleSupélec
**      EDF R&D
**  Contacts:
**      dominique.marcadet@centralesupelec.fr
**      aurelie.dehouck-neveu@edf.fr
**  Web site:
**      http://wdi.supelec.fr/software/RiseClipse/
*************************************************************************
*/
package fr.centralesupelec.edf.riseclipse.iec61850.scl.provider;

import java.util.Collection;
import java.util.List;
import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ViewerNotification;

import fr.centralesupelec.edf.riseclipse.iec61850.scl.AbstractDataAttribute;
import fr.centralesupelec.edf.riseclipse.iec61850.scl.SclFactory;
import fr.centralesupelec.edf.riseclipse.iec61850.scl.SclPackage;

/**
 * This is the item provider adapter for a {@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AbstractDataAttribute} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class AbstractDataAttributeItemProvider extends UnNamingItemProvider {
    /**
     * This constructs an instance from a factory and a notifier.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public AbstractDataAttributeItemProvider( AdapterFactory adapterFactory ) {
        super( adapterFactory );
    }

    /**
     * This returns the property descriptors for the adapted class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public List< IItemPropertyDescriptor > getPropertyDescriptors( Object object ) {
        if( itemPropertyDescriptors == null ) {
            super.getPropertyDescriptors( object );

            addBTypePropertyDescriptor( object );
            addCountPropertyDescriptor( object );
            addSAddrPropertyDescriptor( object );
            addTypePropertyDescriptor( object );
            addValImportPropertyDescriptor( object );
            addValKindPropertyDescriptor( object );
            addRefersToEnumTypePropertyDescriptor( object );
            addRefersToDATypePropertyDescriptor( object );
            addReferredByFCDAPropertyDescriptor( object );
            addReferredByExtRefPropertyDescriptor( object );
            addNamePropertyDescriptor( object );
            addReferredByDAIPropertyDescriptor( object );
            addReferredBySDIPropertyDescriptor( object );
        }
        return itemPropertyDescriptors;
    }

    /**
     * This adds a property descriptor for the BType feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addBTypePropertyDescriptor( Object object ) {
        itemPropertyDescriptors.add(
                createItemPropertyDescriptor( ( ( ComposeableAdapterFactory ) adapterFactory ).getRootAdapterFactory(),
                        getResourceLocator(),
                        getString( "_UI_AbstractDataAttribute_bType_feature" ),
                        getString( "_UI_PropertyDescriptor_description", "_UI_AbstractDataAttribute_bType_feature",
                                "_UI_AbstractDataAttribute_type" ),
                        SclPackage.eINSTANCE.getAbstractDataAttribute_BType(),
                        true,
                        false,
                        false,
                        ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
                        null,
                        null ) );
    }

    /**
     * This adds a property descriptor for the Count feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addCountPropertyDescriptor( Object object ) {
        itemPropertyDescriptors.add(
                createItemPropertyDescriptor( ( ( ComposeableAdapterFactory ) adapterFactory ).getRootAdapterFactory(),
                        getResourceLocator(),
                        getString( "_UI_AbstractDataAttribute_count_feature" ),
                        getString( "_UI_PropertyDescriptor_description", "_UI_AbstractDataAttribute_count_feature",
                                "_UI_AbstractDataAttribute_type" ),
                        SclPackage.eINSTANCE.getAbstractDataAttribute_Count(),
                        true,
                        false,
                        false,
                        ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
                        null,
                        null ) );
    }

    /**
     * This adds a property descriptor for the SAddr feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addSAddrPropertyDescriptor( Object object ) {
        itemPropertyDescriptors.add(
                createItemPropertyDescriptor( ( ( ComposeableAdapterFactory ) adapterFactory ).getRootAdapterFactory(),
                        getResourceLocator(),
                        getString( "_UI_AbstractDataAttribute_sAddr_feature" ),
                        getString( "_UI_PropertyDescriptor_description", "_UI_AbstractDataAttribute_sAddr_feature",
                                "_UI_AbstractDataAttribute_type" ),
                        SclPackage.eINSTANCE.getAbstractDataAttribute_SAddr(),
                        true,
                        false,
                        false,
                        ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
                        null,
                        null ) );
    }

    /**
     * This adds a property descriptor for the Type feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addTypePropertyDescriptor( Object object ) {
        itemPropertyDescriptors.add(
                createItemPropertyDescriptor( ( ( ComposeableAdapterFactory ) adapterFactory ).getRootAdapterFactory(),
                        getResourceLocator(),
                        getString( "_UI_AbstractDataAttribute_type_feature" ),
                        getString( "_UI_PropertyDescriptor_description", "_UI_AbstractDataAttribute_type_feature",
                                "_UI_AbstractDataAttribute_type" ),
                        SclPackage.eINSTANCE.getAbstractDataAttribute_Type(),
                        true,
                        false,
                        false,
                        ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
                        null,
                        null ) );
    }

    /**
     * This adds a property descriptor for the Val Import feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addValImportPropertyDescriptor( Object object ) {
        itemPropertyDescriptors.add(
                createItemPropertyDescriptor( ( ( ComposeableAdapterFactory ) adapterFactory ).getRootAdapterFactory(),
                        getResourceLocator(),
                        getString( "_UI_AbstractDataAttribute_valImport_feature" ),
                        getString( "_UI_PropertyDescriptor_description", "_UI_AbstractDataAttribute_valImport_feature",
                                "_UI_AbstractDataAttribute_type" ),
                        SclPackage.eINSTANCE.getAbstractDataAttribute_ValImport(),
                        true,
                        false,
                        false,
                        ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
                        null,
                        null ) );
    }

    /**
     * This adds a property descriptor for the Val Kind feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addValKindPropertyDescriptor( Object object ) {
        itemPropertyDescriptors.add(
                createItemPropertyDescriptor( ( ( ComposeableAdapterFactory ) adapterFactory ).getRootAdapterFactory(),
                        getResourceLocator(),
                        getString( "_UI_AbstractDataAttribute_valKind_feature" ),
                        getString( "_UI_PropertyDescriptor_description", "_UI_AbstractDataAttribute_valKind_feature",
                                "_UI_AbstractDataAttribute_type" ),
                        SclPackage.eINSTANCE.getAbstractDataAttribute_ValKind(),
                        true,
                        false,
                        false,
                        ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
                        null,
                        null ) );
    }

    /**
     * This adds a property descriptor for the Refers To Enum Type feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addRefersToEnumTypePropertyDescriptor( Object object ) {
        itemPropertyDescriptors.add( createItemPropertyDescriptor(
                ( ( ComposeableAdapterFactory ) adapterFactory ).getRootAdapterFactory(),
                getResourceLocator(),
                getString( "_UI_AbstractDataAttribute_RefersToEnumType_feature" ),
                getString( "_UI_PropertyDescriptor_description", "_UI_AbstractDataAttribute_RefersToEnumType_feature",
                        "_UI_AbstractDataAttribute_type" ),
                SclPackage.eINSTANCE.getAbstractDataAttribute_RefersToEnumType(),
                true,
                false,
                true,
                null,
                null,
                null ) );
    }

    /**
     * This adds a property descriptor for the Refers To DA Type feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addRefersToDATypePropertyDescriptor( Object object ) {
        itemPropertyDescriptors.add(
                createItemPropertyDescriptor( ( ( ComposeableAdapterFactory ) adapterFactory ).getRootAdapterFactory(),
                        getResourceLocator(),
                        getString( "_UI_AbstractDataAttribute_RefersToDAType_feature" ),
                        getString( "_UI_PropertyDescriptor_description",
                                "_UI_AbstractDataAttribute_RefersToDAType_feature", "_UI_AbstractDataAttribute_type" ),
                        SclPackage.eINSTANCE.getAbstractDataAttribute_RefersToDAType(),
                        true,
                        false,
                        true,
                        null,
                        null,
                        null ) );
    }

    /**
     * This adds a property descriptor for the Referred By FCDA feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addReferredByFCDAPropertyDescriptor( Object object ) {
        itemPropertyDescriptors.add(
                createItemPropertyDescriptor( ( ( ComposeableAdapterFactory ) adapterFactory ).getRootAdapterFactory(),
                        getResourceLocator(),
                        getString( "_UI_AbstractDataAttribute_ReferredByFCDA_feature" ),
                        getString( "_UI_PropertyDescriptor_description",
                                "_UI_AbstractDataAttribute_ReferredByFCDA_feature", "_UI_AbstractDataAttribute_type" ),
                        SclPackage.eINSTANCE.getAbstractDataAttribute_ReferredByFCDA(),
                        true,
                        false,
                        true,
                        null,
                        null,
                        null ) );
    }

    /**
     * This adds a property descriptor for the Referred By Ext Ref feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addReferredByExtRefPropertyDescriptor( Object object ) {
        itemPropertyDescriptors.add( createItemPropertyDescriptor(
                ( ( ComposeableAdapterFactory ) adapterFactory ).getRootAdapterFactory(),
                getResourceLocator(),
                getString( "_UI_AbstractDataAttribute_ReferredByExtRef_feature" ),
                getString( "_UI_PropertyDescriptor_description", "_UI_AbstractDataAttribute_ReferredByExtRef_feature",
                        "_UI_AbstractDataAttribute_type" ),
                SclPackage.eINSTANCE.getAbstractDataAttribute_ReferredByExtRef(),
                true,
                false,
                true,
                null,
                null,
                null ) );
    }

    /**
     * This adds a property descriptor for the Name feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addNamePropertyDescriptor( Object object ) {
        itemPropertyDescriptors.add(
                createItemPropertyDescriptor( ( ( ComposeableAdapterFactory ) adapterFactory ).getRootAdapterFactory(),
                        getResourceLocator(),
                        getString( "_UI_AbstractDataAttribute_name_feature" ),
                        getString( "_UI_PropertyDescriptor_description", "_UI_AbstractDataAttribute_name_feature",
                                "_UI_AbstractDataAttribute_type" ),
                        SclPackage.eINSTANCE.getAbstractDataAttribute_Name(),
                        true,
                        false,
                        false,
                        ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
                        null,
                        null ) );
    }

    /**
     * This adds a property descriptor for the Referred By DAI feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addReferredByDAIPropertyDescriptor( Object object ) {
        itemPropertyDescriptors.add(
                createItemPropertyDescriptor( ( ( ComposeableAdapterFactory ) adapterFactory ).getRootAdapterFactory(),
                        getResourceLocator(),
                        getString( "_UI_AbstractDataAttribute_ReferredByDAI_feature" ),
                        getString( "_UI_PropertyDescriptor_description",
                                "_UI_AbstractDataAttribute_ReferredByDAI_feature", "_UI_AbstractDataAttribute_type" ),
                        SclPackage.eINSTANCE.getAbstractDataAttribute_ReferredByDAI(),
                        true,
                        false,
                        true,
                        null,
                        null,
                        null ) );
    }

    /**
     * This adds a property descriptor for the Referred By SDI feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addReferredBySDIPropertyDescriptor( Object object ) {
        itemPropertyDescriptors.add(
                createItemPropertyDescriptor( ( ( ComposeableAdapterFactory ) adapterFactory ).getRootAdapterFactory(),
                        getResourceLocator(),
                        getString( "_UI_AbstractDataAttribute_ReferredBySDI_feature" ),
                        getString( "_UI_PropertyDescriptor_description",
                                "_UI_AbstractDataAttribute_ReferredBySDI_feature", "_UI_AbstractDataAttribute_type" ),
                        SclPackage.eINSTANCE.getAbstractDataAttribute_ReferredBySDI(),
                        true,
                        false,
                        true,
                        null,
                        null,
                        null ) );
    }

    /**
     * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
     * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
     * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Collection< ? extends EStructuralFeature > getChildrenFeatures( Object object ) {
        if( childrenFeatures == null ) {
            super.getChildrenFeatures( object );
            childrenFeatures.add( SclPackage.eINSTANCE.getAbstractDataAttribute_Val() );
        }
        return childrenFeatures;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected EStructuralFeature getChildFeature( Object object, Object child ) {
        // Check the type of the specified child object and return the proper feature to use for
        // adding (see {@link AddCommand}) it as a child.

        return super.getChildFeature( object, child );
    }

    /**
     * This returns AbstractDataAttribute.gif.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Object getImage( Object object ) {
        return overlayImage( object, getResourceLocator().getImage( "full/obj16/AbstractDataAttribute" ) );
    }

    /**
     * This returns the label text for the adapted class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public String getText( Object object ) {
        String label = ( ( AbstractDataAttribute ) object ).getName();
        return label == null || label.length() == 0 ? getString( "_UI_AbstractDataAttribute_type" )
                : getString( "_UI_AbstractDataAttribute_type" ) + " " + label;
    }

    /**
     * This handles model notifications by calling {@link #updateChildren} to update any cached
     * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public void notifyChanged( Notification notification ) {
        updateChildren( notification );

        switch( notification.getFeatureID( AbstractDataAttribute.class ) ) {
        case SclPackage.ABSTRACT_DATA_ATTRIBUTE__BTYPE:
        case SclPackage.ABSTRACT_DATA_ATTRIBUTE__COUNT:
        case SclPackage.ABSTRACT_DATA_ATTRIBUTE__SADDR:
        case SclPackage.ABSTRACT_DATA_ATTRIBUTE__TYPE:
        case SclPackage.ABSTRACT_DATA_ATTRIBUTE__VAL_IMPORT:
        case SclPackage.ABSTRACT_DATA_ATTRIBUTE__VAL_KIND:
        case SclPackage.ABSTRACT_DATA_ATTRIBUTE__NAME:
            fireNotifyChanged( new ViewerNotification( notification, notification.getNotifier(), false, true ) );
            return;
        case SclPackage.ABSTRACT_DATA_ATTRIBUTE__VAL:
            fireNotifyChanged( new ViewerNotification( notification, notification.getNotifier(), true, false ) );
            return;
        }
        super.notifyChanged( notification );
    }

    /**
     * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
     * that can be created under this object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected void collectNewChildDescriptors( Collection< Object > newChildDescriptors, Object object ) {
        super.collectNewChildDescriptors( newChildDescriptors, object );

        newChildDescriptors.add( createChildParameter( SclPackage.eINSTANCE.getAbstractDataAttribute_Val(),
                SclFactory.eINSTANCE.createVal() ) );
    }

}
